<?php

namespace Thunder;

defined('FCPATH') or die("Direct script access denied");

/**
 * Thunder class
 */
class Thunder
{

	public function make(array $args)
	{

		$action 		= $args[1] ?? null;
		$folder 		= $args[2] ?? null;
		$class_name 	= $args[3] ?? null;

		if($action == 'make:plugin')
		{
			$original_folder = $folder;
			$folder = 'plugins/'.$folder;

			if(file_exists($folder))
				$this->message("That plugin folder already exists",true);

			/*main plugin folder*/
			mkdir($folder,0777,true);

			$css_folder = $folder . '/assets/css/';
			mkdir($css_folder,0777,true);

			$js_folder = $folder . '/assets/js/';
			mkdir($js_folder,0777,true);

			$fonts_folder = $folder . '/assets/fonts/';
			mkdir($fonts_folder,0777,true);

			$images_folder = $folder . '/assets/images/';
			mkdir($images_folder,0777,true);

			$controller_folder = $folder . '/controllers/';
			mkdir($controller_folder,0777,true);
			
			$view_folder = $folder . '/views/';
			mkdir($view_folder,0777,true);
			
			$migration_folder = $folder . '/migrations/';
			mkdir($migration_folder,0777,true);
			
			$models_folder = $folder . '/models/';
			mkdir($models_folder,0777,true);

			/*copy files*/
			
			/*plugin file*/
			$plugin_file = $folder . '/plugin.php';
			$plugin_file_source = 'app/thunder/samples/plugin-sample.php';
			
			if(file_exists($plugin_file_source)){
				copy($plugin_file_source, $plugin_file);
			}else{
				$this->message("plugin sample file not found in: ".$plugin_file_source);
			}

			/*controller file*/
			$controller_file = $folder . '/controllers/controller.php';
			$controller_file_source = 'app/thunder/samples/controller-sample.php';
			
			if(file_exists($controller_file_source)){
				copy($controller_file_source, $controller_file);
			}else{
				$this->message("controller sample file not found in: ".$controller_file_source);
			}

			/*view file*/
			$view_file = $folder . '/views/view.php';
			$view_file_source = 'app/thunder/samples/view-sample.php';
			
			if(file_exists($view_file_source)){
				copy($view_file_source, $view_file);
			}else{
				$this->message("view sample file not found in: ".$view_file_source);
			}
 
			/*js file*/
			$js_file = $folder . '/assets/js/plugin.js';
			$js_file_source = 'app/thunder/samples/js-sample.js';
			
			if(file_exists($js_file_source)){
				copy($js_file_source, $js_file);
			}else{
				$this->message("js sample file not found in: ".$js_file_source);
			}

			/*css file*/
			$css_file = $folder . '/assets/css/style.css';
			$css_file_source = 'app/thunder/samples/css-sample.css';
			
			if(file_exists($css_file_source)){
				copy($css_file_source, $css_file);
			}else{
				$this->message("css sample file not found in: ".$css_file_source);
			}
 			
 			/*config file*/
			$config_file = $folder . '/config.json';
			$config_file_source = 'app/thunder/samples/config-sample.json';
			
			if(file_exists($config_file_source)){
				copy($config_file_source, $config_file);
			}else{
				$this->message("config sample file not found in: ".$config_file_source);
			}
 
 			$this->message("Plugin creation complete! Plugin folder: ".$folder);	

		}else
		if($action == 'make:migration')
		{

		}else
		if($action == 'make:model')
		{

		}else
		{
			$this->message("Unknown command ". $action);
		}
		
		
	}
	
	public function help(string|array $version):void
	{

		$version = is_array($version) ? $version[0] : $version;

		echo "

	ThunderPHP v$version Command Line Tool

	Database
	  migrate            Locates and runs a migration from the specified plugin folder.
	  migrate:refresh    Does a rollback followed by a latest to refresh the current state of the database.
	  migrate:rollback   Runs the 'down' method for a migration in the specifiled plugin folder.

	Generators
	  make:plugin        Generates a new folder with all essential plugin files.
	  make:migration     Generates a new migration file.
	  make:model         Generates a new model file.
			
			";
	}

	private function message(string $message, bool $die = false):void 
	{
		echo "\n\r" . ucfirst($message);
		ob_flush();

		if($die) die();
	}
}